﻿namespace U2UConsult.Win8.DocumentLibrarySample
{
    using System;
    using System.IO;
    using U2UConsult.Win8.DocumentLibrarySample.Models;
    using Windows.ApplicationModel.Activation;
    using Windows.Storage.AccessCache;
    using Windows.UI.Xaml;
    using Windows.UI.Xaml.Controls;

    sealed partial class App : Application
    {
        public App()
        {
            this.InitializeComponent();
        }

        protected async override void OnLaunched(LaunchActivatedEventArgs args)
        {
            await AppModel.EnsureFolderExists();

            Frame rootFrame = Window.Current.Content as Frame;

            if (rootFrame == null)
            {
                rootFrame = new Frame();
                Window.Current.Content = rootFrame;
            }

            if (rootFrame.Content == null)
            {
                if (!rootFrame.Navigate(typeof(MainPage), args.Arguments))
                {
                    throw new Exception("Failed to create initial page");
                }
            }

            Window.Current.Activate();
        }

        protected override void OnFileActivated(FileActivatedEventArgs args)
        {

            if (args.Files.Count > 0)
            {
                var file = args.Files[0];

                Frame rootFrame = Window.Current.Content as Frame;

                if (rootFrame == null)
                {
                    rootFrame = new Frame();
                    Window.Current.Content = rootFrame;
                }

                // MRU list
                var name = Path.GetFileNameWithoutExtension(file.Name);
                StorageApplicationPermissions.MostRecentlyUsedList.Add(file, name);

                if (!rootFrame.Navigate(typeof(MainPage), name))
                {
                    throw new Exception("Failed to create initial page");
                }

                Window.Current.Activate();
            }
        }
    }
}